c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


	subroutine check_limits_2D
	include 'common.2D'

      zmax=0
	ncases=0

	do i=nbp1,np ! Check if any fluid particle is over the box
	   if(zp(i).gt.zmax) zmax=zp(i)
	   if(iflag(i).eq.1.and.(xp(i).gt.xmax_container.or.
     +      xp(i).lt.xmin_container.or.zp(i).lt.zmin_container)) then	 
            iflag(i)=0
	      ncases=ncases+1
	      xp(i)=xtrash
	      zp(i)=ztrash
	      up(i)=0.
	      wp(i)=0.
	      um1(i)=0.
	      uo(i)=0.
             wm1(i)=0.
	      wo(i)=0.
         endif   
	enddo

      differ=(zmax-zcontrol)
   
       if (differ.gt.0) then     
          nn=int(differ*one_over_2h)+1
          zmax = zcontrol + two_h*nn
          ncz = int( (zmax-zmin)*one_over_2h ) + 1
          nct = ncx*ncz !2D
          do i=nct_ini+1,nct
             nc(i,1)  = 0 !No Boundary Particles in these cells               
          enddo
       else
         zmax=zcontrol
         nct=nct_ini
         ncz=ncz_ini
       endif	

	
      if (ncases.ne.0) write(80,*) 'Number ',ncases,' time',time
      if (ncases.ne.0) write(*,*) 'Number ',ncases,' time',time

       if(nct.gt.nct_max.or.ncz.lt.1)then
         write(80,*) ' '
         write(80,*)'ERROR in check_limits_2D.f'
         write(80,*)'nct.gt.nct_max.or.ncz.lt.1'
         write(80,*)'ncx/z    = ',ncx,ncz
         write(80,*)'nct= ',nct
         write(80,*)'nct_max ',nct_max
         write(80,*)'itime  ', itime
c        -- screen printout ---              
         write(*,*) ' '
         write(*,*)'ERROR in check_limits_2D.f'
         write(*,*)'nct.gt.nct_max.or.ncz.lt.1'
         write(*,*)'ncx/z    = ',ncx,ncz
         write(*,*)'nct= ',nct
         write(*,*)'nct_max ',nct_max
         write(*,*)'itime  ', itime
         stop
       endif

      return
	end
