c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.
       
       subroutine divide(n_start,n_end,kind_p)
       include 'common.2D'
       
c     ist and ien are the starting and ending values of the positions in the linear
c     array ip (corresponding to a list of particle numbers) for the particles 
c     in cell ii
c
       do k=n_start,n_end
         if (iflag(k).ne.0) then
         	
           dx = xp(k) - xmin
           dz = zp(k) - zmin
       
           icell = int( dx * one_over_2h ) + 1
           kcell = int( dz * one_over_2h ) + 1
       
           ! ii is the linear cell position in the matrix of 2h cells
           ii    = icell + (kcell - 1)*ncx 
                                                        
           ! nc is the number of particles in cell ii
           nc(ii,kind_p) = nc(ii,kind_p)+1	
                                      
          if(nc(ii,kind_p).gt.nplink_max)then
           write(80,*) ' '
           write(80,*)'ERROR in divide_2D.f'
           write(80,*)'nc(ii,kind_p) >= nplink_max'
           write(80,*)'itime',itime
           write(80,*)'nc(ii,kind_p)',nc(ii,kind_p)
           write(80,*)'kind_p       ',kind_p
           write(80,*)'nplink_max',nplink_max
           write(80,*)'k',k
           write(80,*)'xp(k), zp(k)',xp(k), zp(k)
           write(80,*)'icell, kcell ',icell, kcell
           write(80,*)'Box ii ',ii
c          -- screen printout ---              
           write(*,*) ' '
           write(*,*)'ERROR in divide_2D.f'
           write(*,*)'nc(ii,kind_p) >= nplink_max'
           write(*,*)'itime',itime
           write(*,*)'nc(ii,kind_p)',nc(ii,kind_p)
           write(*,*)'kind_p       ',kind_p
           write(*,*)'nplink_max',nplink_max
           write(*,*)'k',k
           write(*,*)'xp(k), zp(k)',xp(k), zp(k)
           write(*,*)'icell, kcell ',icell, kcell
           write(*,*)'Box ii ',ii
           stop
          end if
          
          ibox(ii,kind_p,nc(ii,kind_p))=k  !Tells us that particle with array location k (i.e. xp(k) )  
                                         !is in box ii which, so far, contains "nc(ii,mkind)" particles
         
         endif
       enddo 
       
       return
       end

